<?php
namespace FiloBlu\CustomReindex\Controller\Adminhtml\Product;
use Magento\Backend\App\Action\Context;
use Magento\Backend\Model\View\Result\RedirectFactory;
use Magento\Ui\Component\MassAction\Filter;
use Magento\Catalog\Model\ResourceModel\Product\CollectionFactory;
use Magento\Catalog\Controller\Adminhtml\Product\Builder;
use Psr\Log\LoggerInterface;

class Reindex extends \Magento\Catalog\Controller\Adminhtml\Product {

	/**
     * @var Filter
     */
    protected $_filter;
    /**
     * @var CollectionFactory
     */
    protected $_collectionFactory;
    /**
     * @var LoggerInterface
     */
    protected $_loggerInterface;
    /**
     * @param Context
     */
    protected $_context;
     /**
     * @param MessageManager
     */
    protected $_messageManager;
    /**
     * @var RedirectFactory
     */
    protected $_resultRedirectFactory;

	protected $resource;
     
    public function __construct(
        Context $_context,
        Builder $_productBuilder,
        Filter $_filter,
        CollectionFactory $_collectionFactory,
		\Magento\Framework\App\ResourceConnection $resource,
        LoggerInterface $_loggerInterface
    ) {
    	
        $this->_collectionFactory = $_collectionFactory;
        $this->_filter = $_filter;
        $this->_loggerInterface = $_loggerInterface;
        $this->_context = $_context;
		$this->resource = $resource;
        $this->_messageManager = $this->_context->getMessageManager();
        $this->_resultRedirectFactory = $this->_context->getResultRedirectFactory();

        parent::__construct( $this->_context, $_productBuilder );
    
    }
    
    public function execute() {
	

		//$productSelected =  $this->getRequest()->getParam('id');

		$collection = $this->_filter->getCollection( $this->_collectionFactory->create() );
		$collection->addAttributeToSelect( 'entity_id' );
		$productIds = $collection->getAllIds();
		if( 0 !== count( $productIds )) {
			if(count($productIds) <= 1000){
		
			try {

					$resource = $this->resource;
					$connection = $resource->getConnection();


				$data =['catalog_product_price_cl',
					'cataloginventory_stock_cl',
					'catalogrule_product_cl',
					'catalog_product_attribute_cl',
					'catalog_category_product_cl',
					'catalog_product_category_cl',
					'catalogsearch_fulltext_cl',
					'targetrule_product_rule_cl',
					'targetrule_rule_product_cl',
					'catalog_product_flat_cl'];

				foreach ($productIds as $product)
				{
					foreach ($data as $tableName)
					{
						$sql = "Insert Into " . $tableName . "(entity_id ) Values ($product)";
						$connection->query($sql);
					}
				}

				$this->_messageManager->addSuccessMessage( __( '%1 product(s) have been update giovanotto/a' , count( $productIds ) ) );
			
			} catch( \Magento\Framework\Exception\LocalizedException $e ) {
			
				$this->_loggerInterface->critical( $e );
				$this->_messageManager->addError( $e->getMessage() );
			
			}
			catch (\Exception $e) {
			
				$this->_loggerInterface->critical( $e );
				$this->_getSession()->addException( $e, __('Something went wrong while updating the product(s).' ));
			}
			}
			else {
				$this->_messageManager->addErrorMessage( __( 'select maximum 1000 products' ));
			}
		
		}
		else {
		
			$this->_messageManager->addErrorMessage( __( 'No Products Selected' ) );
		
		}
		$resultRedirect = $this->_resultRedirectFactory->create();
        return $resultRedirect->setPath( $this->getUrl( 'catalog/product/index' ) );
	
	}




}
